function [N] = rad_pop_LU(ACT_RATIO,t)

%%%%% inputs %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                           %
% t = time                                  %
% ACT_RATIO = activity ratio of U234/U238   %
%                                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

a = 1/t(end);

L234 = log(2)/2.455E5;
L235 = log(2)/7.038E8;
L238 = log(2)/4.468E9;
L230 = log(2)/7.538E4;
L231 = log(2)/3.276E4;

c = ACT_RATIO*L238/L234;

U238 = a.*t;

%b = 137.88*a;   % if atomic values are required
b = a;
U235 = b.*t;

P231 = (b*L235/L231^2).*(exp(-L231.*t) + L231.*t - 1);
P231 = P231.*(L231/L235);

U234 = ( (L238*a/L234^2)-(a*c/L234) ).*exp(-L234.*t) + ...
    (L238*a/L234).*t + a*c/L234 - L238*a/L234^2;
U234 = U234.*(L234/L238);

T230 = (L238*a/(L234*(L230-L234)) - a*c/(L230-L234)).*exp(-L234.*t) + ...
    ( a*c/(L230-L234) - L238*a/(L234*(L230-L234)) + L238*a/L230^2 + ...
      L238*a/(L230*L234) - a*c/L230 ) .* exp(-L230.*t) + (L238*a/L230).*t + ...
    a*c/L230 - L238*a/(L230*L234) - L238*a/L230^2;
T230 = T230.*(L230/L238);

N = [U238 U234 T230 U235 P231];
